Summary:	Software watchdog, but less drastic than the usual solutions
Name:		watchcatd
Version:	1.2
Release:	%mkrel 2
License:	GPLv2+
Group:		System/Servers
URL:		http://oss.digirati.com.br/watchcatd/
Source0:	http://oss.digirati.com.br/watchcatd/%{name}-%{version}.tar.gz
Source1:	watchcatd.init
Source2:	watchcatd.sysconfig
Patch0:		watchcatd-pid_and_socket_fix.diff
Patch1:		watchcatd-build_fix.diff
Requires(post): rpm-helper
Requires(preun): rpm-helper
BuildRequires:	libevent-devel >= 1.3
BuildRequires:	libwcat-devel >= 1.1
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
watchcatd is a software service that monitors processes. A bug or malicious
attacks to machine can lock up a process, leading to a deadlock or an
unexpected condition. If a monitored process locks up, it is killed. 

On an alternate setup, watchcatd can be configured to work as a timer.

%prep

%setup -q
%patch0 -p1
%patch1 -p0

cp %{SOURCE1} watchcatd.init
cp %{SOURCE2} watchcatd.sysconfig

mv tester/cattester.c .
rm -f tester/Makefile

# lib64 fixes
perl -pi -e "s|/usr/lib\b|%{_libdir}|g" *

%build

%make CFLAGS="%{optflags}"

gcc %{optflags} -c cattester.c
gcc %{optflags} -o cattester cattester.o -lwcat

%install
rm -rf %{buildroot}

# don't fiddle with the initscript!
export DONT_GPRINTIFY=1

install -d %{buildroot}%{_sbindir}
install -d %{buildroot}%{_initrddir}
install -d %{buildroot}%{_sysconfdir}/sysconfig
install -d %{buildroot}%{_libdir}/watchcatd
install -d %{buildroot}%{_mandir}/man{5,8}
install -d %{buildroot}/var/run/watchcatd
install -d %{buildroot}/var/lib/watchcatd

install -m0755 catmaster %{buildroot}%{_libdir}/watchcatd
install -m0755 catslave %{buildroot}%{_libdir}/watchcatd
install -m0755 wcatstat %{buildroot}%{_sbindir}/
install -m0755 cattester %{buildroot}%{_sbindir}/

install -m0755 watchcatd.init %{buildroot}%{_initrddir}/watchcatd
install -m0644 watchcatd.prod.conf %{buildroot}%{_sysconfdir}/watchcatd.conf
install -m0644 watchcatd.sysconfig %{buildroot}%{_sysconfdir}/sysconfig/watchcatd
install -m0644 watchcatd.8 %{buildroot}%{_mandir}/man8/
install -m0644 watchcatd.conf.5 %{buildroot}%{_mandir}/man5/

%pre
%_pre_useradd watchcat /var/lib/watchcat /bin/false

%post
%_post_service watchcatd

%preun
%_preun_service watchcatd

%postun
%_postun_userdel watchcat

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root)
%doc ChangeLog TODO tester
%attr(0755,root,root) %{_initrddir}/watchcatd
%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/watchcatd.conf
%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/sysconfig/watchcatd
%attr(0755,root,root) %{_sbindir}/cattester
%attr(0755,root,root) %{_libdir}/watchcatd/catmaster
%attr(0755,root,root) %{_libdir}/watchcatd/catslave
%attr(0755,root,root) %{_sbindir}/wcatstat
%{_mandir}/man8/*
%{_mandir}/man5/*
%dir %attr(0755,watchcat,watchcat) /var/run/watchcatd
%dir %attr(0755,watchcat,watchcat) /var/lib/watchcatd


%changelog
* Sat Sep 06 2008 Oden Eriksson <oeriksson@mandriva.com> 1.2-2mdv2009.0
+ Revision: 282016
- fix deps

* Sat Sep 06 2008 Oden Eriksson <oeriksson@mandriva.com> 1.2-1mdv2009.0
+ Revision: 281984
- 1.2

  + Thierry Vignaud <tvignaud@mandriva.com>
    - rebuild early 2009.0 package (before pixel changes)

  + Pixel <pixel@mandriva.com>
    - adapt to %%_localstatedir now being /var instead of /var/lib (#22312)

* Wed May 14 2008 Oden Eriksson <oeriksson@mandriva.com> 1.1-6mdv2009.0
+ Revision: 207057
- rebuilt against libevent-1.4.4

* Sun Dec 30 2007 Funda Wang <fundawang@mandriva.org> 1.1-5mdv2008.1
+ Revision: 139488
- rebuild

  + Olivier Blin <oblin@mandriva.com>
    - restore BuildRoot

  + Thierry Vignaud <tvignaud@mandriva.com>
    - fix prereq on rpm-helper
    - kill re-definition of %%buildroot on Pixel's request


* Sat Dec 09 2006 Oden Eriksson <oeriksson@mandriva.com> 1.1-4mdv2007.0
+ Revision: 94278
- Import watchcatd

* Wed Sep 13 2006 Oden Eriksson <oeriksson@mandriva.com> 1.1-4mdv2007.0
- rebuild

* Sat Aug 06 2005 Oden Eriksson <oeriksson@mandriva.com> 1.1-3mdk
- rebuilt against latest libevent (for x86_64)

* Tue May 10 2005 Oden Eriksson <oeriksson@mandriva.com> 1.1-2mdk
- rebuilt against new libevent (new major)
- rpmlint fixes

* Tue Jan 04 2005 Oden Eriksson <oeriksson@mandrakesoft.com> 1.1-1mdk
- initial mandrake package, used parts of the provided spec file
- added S1,S2 and P0

